#include "trim_straggling.h"
///*
//初始化Chu电子岐离参数表
//*/
//inline boost::multi_array<double, 2> initialize_chu_table() {
//    boost::multi_array<double, 2> database(boost::extents[92][4]);
//    std::ifstream out(".\\data\\chu_table.dat", std::ifstream::in);//打开文件，为存放目录下的data.txt文件
//    std::string line, word;
//    std::array<double, 5> element = { 0 };//用来存一行

//    database[0][0] = 0;
//    database[0][1] = 0;
//    database[0][2] = 0;
//    database[0][3] = 0;

//    int i = 1;
//    while (std::getline(out, line)) {//读一行，放到line里
//        int j = 0;
//        std::istringstream record(line);
//        while (record >> word) { //从一行里读一个数据
//            element[j] = stod(word); //将数据字符串转化为double类型
//            j++;
//        }
//        for (int k = 0; k < 4; k++) {
//            database[i][k] = element[k + 1]; //将一行存进数组
//        }
//        i++;
//    }
//    return database;
//}
///*
//计算电子岐离
//*/
//inline double calculate_straggling_coff(const unsigned int Z1, const double M1, const double E, const unsigned int Z2, double num_density) {
//    constexpr double e2 = 14.4;
//    static boost::multi_array<double, 2> chu_table = initialize_chu_table();

//    double S1 = calculate_elec_loss_coff_trim85(Z1, M1, Z2, E / 1000);
//    double SH = calculate_elec_loss_coff_trim85(1, 1.0078, Z2, E / 1000);
//    double eff_charge2 = S1 / (SH * Z1 * Z1);
//    double omega_bohr2 = 4.0 * std::numbers::pi * pow(Z1, 2) * pow(e2, 2) * Z2 * num_density;

//    double E_MeV = E / M1 / 1e6;
//    //std::cout << chu_table[Z2-1][0] << " " << chu_table[Z2-1][1] << " " << chu_table[Z2-1][2] << " " << chu_table[Z2-1][3] << std::endl;
//    double correction_chu = 1.0 / (1 + chu_table[Z2 - 1][0] * pow(E_MeV, chu_table[Z2 - 1][1]) + chu_table[Z2 - 1][2] * pow(E_MeV, chu_table[Z2 - 1][3]));

//    double gamma;
//    double correction_yang;
//    if (Z1 == 1) {
//        gamma = 2.522 * (1 - exp(-1.040 * E_MeV));
//        correction_yang = 0.1955 * gamma / (pow(E_MeV - 0.6941, 2) + pow(gamma, 2));
//    }
//    else
//    {
//        gamma = 0.3931 * (1 - exp(-3.812 * E_MeV / pow(Z1, 1.5) / sqrt(Z2)));
//        correction_yang = pow(Z1, 4 / 3) / pow(Z2, 1 / 3) * (1.273e-2) * gamma / (pow(E_MeV / pow(Z1, 1.5) / sqrt(Z2) - (3.458e-2), 2) + pow(gamma, 2));
//    }
//    //std::cout << omega_bohr2 << std::endl;
//    return (eff_charge2 * correction_chu + correction_yang) * omega_bohr2;
//}
